<?php
/**
 * @author Arnaud AUZOLAT <arnaud.auzolat@libriciel.coop>
 * @editor Libriciel SCOP
 *
 * @created 19 sept 2018
 *
 *
 */
class LocaleoComponent extends Component {

    public $responseMessage;
    public $apiKey;
    public $appName;
    public $responseMessageStr;
    public $wsto;
    public $wsdl;
    public $clientcert;
    public $passphrase;
    public $userpwd;
    public $boundary;

    function LocaleoComponent() {
        $this->apiKey = "7a1182abe571c90584c2541ecs3a0f54";
        $this->appName = "Webgfc";
    }

    function LancerRequeteCurl($request, $attachments = null, $datas = array(), $etat = null, $note = null) {

        // selon la requête adressée, on défini l'action derrière
        $this->wsto = 'https://grc28.localeo.fr/public/webgfc/'.$request;
                
        if( $request == 'createquery' ) {
            if( ( isset($datas['Contact']) && !empty($datas['Contact'] ) || ( isset($datas['Courrier']) && !empty($datas['Courrier']['contact_id']) ) )  ){
                $datasToSendContact = $this->table_correspondance($datas, true, true);
                $dataToGRC = $datasToSendContact;
            }
        }
        else if( $request == 'createaccount' ) {
            $datasToSend = $this->table_correspondance($datas, true, true);

            $dataToGRC = array(
                'citoyen' => json_encode(
                    $datasToSend
                )
            );
        }
        else if( $request == 'getstatusquery' ) {
            $dataFixed = array(
                'cityId' => Configure::read('GRC.cityId'),
                'canalId' => Configure::read('GRC.canalId'),
                'servId' => Configure::read('GRC.servId'),
                'sqrtId' => Configure::read('GRC.sqrtId'),
                'qrtId' => Configure::read('GRC.qrtId')
            );
            $data = array(
                'requete' => json_encode(
                    array(
                        'id' => $datas
                    )
                )
            );
        
            $datasToSend = array_merge( $dataFixed, $data);
            $this->wsto = 'https://grc28.localeo.fr/public/webgfc/'.$request;
            $dataToGRC = $datasToSend;
        }
        else if( $request == 'updatestatusquery' ) {
            $dataFixed = array(
                'cityId' => Configure::read('GRC.cityId'),
                'canalId' => Configure::read('GRC.canalId'),
                'servId' => Configure::read('GRC.servId'),
                'sqrtId' => Configure::read('GRC.sqrtId'),
                'qrtId' => Configure::read('GRC.qrtId')
            );
            $data = array(
                'requete' => json_encode(
                    array(
                        'id' => $datas,
                        'statusId' => $etat,
                        'note' => $note
                    )
                )
            );
        
            $datasToSend = array_merge( $dataFixed, $data);
            $this->wsto = 'https://grc28.localeo.fr/public/webgfc/'.$request;
            $dataToGRC = $datasToSend;
        }
        else {
            $dataToGRC = $datas;
        }

//$this->log($dataToGRC);
//die();


        $ch = curl_init ();
        curl_setopt($ch, CURLOPT_URL, $this->wsto);
        curl_setopt($ch,CURLOPT_HTTPHEADER,array("Api-Key: {$this->apiKey}", "appName: {$this->appName}"));
        curl_setopt($ch, CURLOPT_POSTFIELDS, $dataToGRC);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
       
        $reply = curl_exec($ch);
        curl_close($ch);
        $this->responseMessageStr = json_decode ( $reply );
//        $response = json_decode ( $reply );
//        echo $reply."\n";
//$this->log(  $this->responseMessageStr );
        return true;
    }
    
    function echoTest() {
        $request = 'getstatusquery';
        $dataFixed = array(
            'cityId' => Configure::read('GRC.cityId'),
            'canalId' => Configure::read('GRC.canalId'),
            'servId' => Configure::read('GRC.servId'),
            'sqrtId' => Configure::read('GRC.sqrtId'),
            'qrtId' => Configure::read('GRC.qrtId')
        );
        $data = array(
            'requete' => json_encode(
                array(
                    'id' => 1633315
                )
            )
        );
        
        // $servId ===> à paramétrer pour chaque servie
        // dès qu'un type
        $datasToSend = array_merge( $dataFixed, $data);
        $this->lancerRequeteCurl($request, null, $datasToSend);
        return $this->responseMessageStr;
    }

    /**
     * Création d'une requête dans la GRC
     * @param type $data
     * @return type
     */
    function createRequestGRC( $data ) {
        $request = 'createquery';
        $this->lancerRequeteCurl($request, null, $data);
        return $this->responseMessageStr;
    }

    /**
     *  Création d'un contact (de type citoyen)
     * @param type $data
     * @return type
     */
    function createContactGRC($data) {
        $request = 'createaccount';
        $this->lancerRequeteCurl($request, null, $data);
        return $this->responseMessageStr;
    }
    
    /**
     *  Création d'un contact (de type organisme)
     * @param type $data
     * @return type
     */
    function createOrganismeGRC($data) {
        $request = 'createaccount';
        $this->lancerRequeteCurl($request, null, $data);
        return $this->responseMessageStr;
    }
    
    /**
     * Fonction permettant de transformer les données de la GRC Localeo vers la BDD de web-GFC
     * @param type $data
     * @param type $collectiviteId
     * @return type
     */
    function table_correspondance($data, $forContact,  $fromGFC) {
        $dataFixed = array(
            'cityId' => Configure::read('GRC.cityId'),
            'canalId' => Configure::read('GRC.canalId'),
            'servId' => Configure::read('GRC.servId'),
            'sqrtId' => Configure::read('GRC.sqrtId'),
            'qrtId' => Configure::read('GRC.qrtId')
        );
//$this->log( $data ); die();
        // Enregistrement du contact TOUT SEUL Courriers/add_contact.ctp)
        if( $forContact && isset($data['Contact']['externalId']) && !empty( $data['Contact']['externalId'] ) ) {
$this->log('Création du contact depuis web-GFC vers la GRC');
            if( !$fromGFC ) {
                if(!empty($data['ext'])) {
                    $numvoie = $data['num'].' '.$data['ext'];
                }
                else {
                    $numvoie = $data['num'];
                }
                if( !empty($data['additionalAddress2'])) {
                    $complAddress = $data['additionalAddress'].' '.$data['additionalAddress2'];
                }
                else {
                    $complAddress = $data['additionalAddress'];
                }

                if( !empty($data['usualName']) ) {
                    $usualName = $data['usualName'];
                }
                else {
                    $usualName = $data['firstname'].' ' .$data['familyName'];
                }
            
                $dataForGRC = array(
                    'civilite' => isset( $data['civility'] ) ? $data['civility'] : null,
                    'name' => $usualName,
                    'nom' => isset( $data['familyName'] ) ? $data['familyName'] : null,
                    'prenom' => isset( $data['firstname'] ) ? $data['firstname'] : null,
                    'email' => isset( $data['email'] ) ? $data['email'] : null,
                    'tel' => isset($data['phone']) ? $data['phone'] : null,
                    'portable' => isset( $data['gsm'] ) ? $data['gsm'] : null,
                    'numvoie' => $numvoie, // n° de voie + extension de n°
                    'adresse' => isset( $data['street'] ) ? $data['street'] : null,
                    'adressecomplete' => isset( $data['street'] ) ? $data['street'] : null,
                    'compl' => $complAddress,
                    'cp' => isset( $data['ZC'] ) ? $data['ZC'] : null,
                    'ville' => isset( $data['city'] ) ? $data['city'] : null,
                    'pays' => isset( $data['country'] ) ? $data['country'] : null,                
                    'lignedirecte' => isset( $data['phonePro'] ) ? $data['phonePro'] : null,
                    'contactgrc_id' => $data['externalId'],
                    'organisme_id' => $data['organismeId']
                );
            }
            else {
                $this->Contact = ClassRegistry::init('Contact');
                $org = $this->Contact->Organisme->find( 
                    'first',
                    array(
                        'conditions' => array(
                            'Organisme.id' => $data['Contact']['organisme_id']
                        ),
                        'recursive' => -1,
                        'contain' => false
                    )
                );
                // Si le contact n'existe pas encore dans la GRC, on le crée
                if( empty($data['Contact']['contactgrc_id']) ) {
$this->log('Création du contact dans la GRC');
                    $dataForGRC = array_merge(
                        $dataFixed,
                        array(
                            'externalId' => $data['Contact']['externalId'],
                            'usualName' => $data['Contact']['name'],
                            'familyName' => $data['Contact']['nom'],
                            'firstname' => $data['Contact']['prenom'],
                            'civility' => $data['Contact']['civilite'],
                            'company' => $org['Organisme']['name'],
                            'num' => $data['Contact']['numvoie'],
                            'email' => $data['Contact']['email'],
                            'ZC' => $data['Contact']['cp'],
                            'city' => $data['Contact']['ville'],
                            'country' => $data['Contact']['pays'],
                            'gsm' => $data['Contact']['portable'],
                            'phone' => $data['Contact']['tel'],
                            'phonePro' => $data['Contact']['lignedirecte'],
                            'street' => $data['Contact']['adresse'],
                            'ext' => $data['Contact']['compl']
                        )
                    );
                }
                // Si le contact existe déjà dans la GRC, on met ses informations à jour
                else {
$this->log('Mise à jour du contact dans la GRC');
                    $dataForGRC = array_merge(
                        $dataFixed,
                        array(
                            'id' => $data['Contact']['contactgrc_id'],
                            'externalId' => $data['Contact']['externalId'],
                            'usualName' => $data['Contact']['name'],
                            'familyName' => $data['Contact']['nom'],
                            'firstname' => $data['Contact']['prenom'],
                            'civility' => $data['Contact']['civilite'],
                            'company' => $org['Organisme']['name'],
                            'num' => $data['Contact']['numvoie'],
                            'email' => $data['Contact']['email'],
                            'ZC' => $data['Contact']['cp'],
                            'city' => $data['Contact']['ville'],
                            'gsm' => $data['Contact']['portable'],
                            'phone' => $data['Contact']['tel'],
                            'phonePro' => $data['Contact']['lignedirecte'],
                            'country' => $data['Contact']['pays'],
                            'street' => $data['Contact']['adresse'],
                            'ext' => $data['Contact']['compl'],
                        )
                    );
                }
            }
        }
        // enregistrement du flux avec contact déjà ajouté (edit_contact)
        else if( $forContact && isset($data['Courrier']['contact_id']) && !empty($data['Courrier']['contact_id'])) {
$this->log('Création du contact et association à une requête depuis web-GFC vers la GRC');
            $this->Contact = ClassRegistry::init('Contact');
            $contact = $this->Contact->find( 
                'first',
                array(
                    'conditions' => array(
                        'Contact.id' => $data['Courrier']['contact_id']
                    ),
                    'recursive' => -1,
                    'contain' => false
                )
            );
            if(!empty($contact)) {
$this->log('Contact déjà existant dans web-GFC');
                // Le contact existe déjà dans la GRC , on l'assacie donc à la requête dans la GRC
                if( !empty( $contact['Contact']['contactgrc_id'] ) ) {
$this->log('Contact déjà existant dans web-GFC et la GRC');
                    $dataForGRC = array(
                        'requete' => json_encode(
                            array_merge(
                                $dataFixed,
                                array(
                                    'subject' => $data['Courrier']['name'],
                                    'content' => $data['Courrier']['objet'],
                                    'geo' => '',
                                    'externalId' => $data['Courrier']['id'],
                                    /*'civility' => $contact['Contact']['civilite'],
                                    'usualName' => $contact['Contact']['name'],
                                    'familyName' => $contact['Contact']['nom'],
                                    'firstname' => $contact['Contact']['prenom'],
                                    'company' => '',
                                    'email' => $contact['Contact']['email'],
                                    'gsm' => '',
                                    'phone' => '',
                                    'num' => $contact['Contact']['numvoie'],
                                    'ext' => '',
                                    'street' => $contact['Contact']['adresse'],
                                    'additonalAddress' => $contact['Contact']['adresse'],
                                    'ZC' => $contact['Contact']['cp'],
                                    'city' => $contact['Contact']['ville'],
                                    'country',
                                    'geoType' => '',
                                    'numberIdAddr' => '',
                                    'streetIdAddr' => '',
                                    'cityIdAddr' => ''*/
                                )
                            )
                        ),
                        'citoyen' => json_encode(
                            array(
                                'id' => $contact['Contact']['contactgrc_id'],
                                'externalId' => $contact['Contact']['externalId']
                            )
                        )
                    );
                }
                else {
$this->log('Contact déjà existant dans web-GFC mais pas dans la GRC, on ne le crée pas');
                    // il n'existe pas, on ne le prend pas en compte
                    $dataForGRC = array(
                        'requete' => json_encode(
                            array_merge(
                                $dataFixed,
                                array(
                                    'subject' => $data['Courrier']['name'],
                                    'content' => $data['Courrier']['objet'],
                                    'geo' => false,
                                    'externalId' => $data['Courrier']['id'],
                                    /*'civility' => $contact['Contact']['civilite'],
                                    'usualName' => $contact['Contact']['name'],
                                    'familyName' => $contact['Contact']['nom'],
                                    'firstname' => $contact['Contact']['prenom'],
                                    'company' => '',
                                    'email' => $contact['Contact']['email'],
                                    'gsm' => '',
                                    'phone' => '',
                                    'num' => $contact['Contact']['numvoie'],
                                    'ext' => '',
                                    'street' => $contact['Contact']['adresse'],
                                    'additonalAddress' => $contact['Contact']['adresse'],
                                    'ZC' => $contact['Contact']['cp'],
                                    'city' => $contact['Contact']['ville'],
                                    'country',
                                    'geoType' => '',
                                    'numberIdAddr' => '',
                                    'streetIdAddr' => '',
                                    'cityIdAddr' => ''*/
                                )
                            )
                        )
                    );
                }
            }
        }
        else if( $forContact && isset($data['Organisme']['externalId']) && !empty($data['Organisme']['externalId'])) {
$this->log('Création dun organisme depuis web-GFC vers la GRC');
            $this->Organisme = ClassRegistry::init('Organisme');
            $org = $this->Organisme->find( 
                'first',
                array(
                    'conditions' => array(
                        'Organisme.id' => $data['Organisme']['externalId']
                    ),
                    'recursive' => -1,
                    'contain' => false
                )
            );
            // L'organisme existe déjà dans web-GFC ET la gRC
            if( !empty($org) ) {
$this->log('Création dun organisme existant dans web-GFC vers la GRC');
                // L'organisme existe déjà dans la GRC ET on crée une requête dans la GRC, on l'associe donc à la requête dans la GRC
                if( !empty( $org['Organisme']['contactgrc_id'] ) && !empty($data['Courrier']['id']) ) {
$this->log('Organisme existant dans web-GFC ET dans la GRC et association avec une requête');
                    $dataForGRC = array(
                        'requete' => json_encode(
                            array_merge(
                                $dataFixed,
                                array(
                                    'subject' => $data['Courrier']['name'],
                                    'content' => $data['Courrier']['objet'],
                                    'geo' => '',
                                    'externalId' => $data['Courrier']['id'],
                                    'company' => $data['Organisme']['name']
                                )
                            )
                        ),
                        'citoyen' => json_encode(
                            array(
                                'id' => $org['Organisme']['contactgrc_id'],
                                'externalId' => $org['Organisme']['externalId']
                            )
                        )
                    );
                }
                else {
                    // L'organisme existe déjà dans la GRC ET existe dans web-GFC,  on met simplement ses infos à jour dans la GRC
                    if( !empty( $data['Organisme']['contactgrc_id'] ) ) {
$this->log('Organisme existant dans web-GFC ET dans la GRC');
                        $dataForGRC = array_merge(
                            $dataFixed,
                            array(
                                'id' => $org['Organisme']['contactgrc_id'],
                                'externalId' => $data['Organisme']['externalId'],
                                'num' => $data['Organisme']['numvoie'],
                                'company' => $data['Organisme']['name'],
                                'email' => $data['Organisme']['email'],
                                'ZC' => $data['Organisme']['cp'],
                                'city' => $data['Organisme']['ville'],
                                'usualName' => $data['Organisme']['name'],
                                'familyName' => $data['Organisme']['name'],
                                'firstname' => $data['Organisme']['name'],
                                'street' => $data['Organisme']['adresse'],
                                'ext' => $data['Organisme']['compl'],
                                'gsm' => $data['Organisme']['portable'],
                                'phone' => $data['Organisme']['tel'],
                                'country' => $data['Organisme']['pays' ]
                            )
                        );
                    }
                    else {
$this->log('Organisme existant dans web-GFC mais pas dans la GRC');
                        // L'organisme n'existe pas dans la GRC ET existe dans web-GFC,  on le crée dans la gRC
                        $dataForGRC = array_merge(
                            $dataFixed,
                            array(
                                'externalId' => $data['Organisme']['externalId'],
                                'num' => $data['Organisme']['numvoie'],
                                'company' => $data['Organisme']['name'],
                                'email' => $data['Organisme']['email'],
                                'ZC' => $data['Organisme']['cp'],
                                'city' => $data['Organisme']['ville'],
                                'usualName' => $data['Organisme']['name'],
                                'familyName' => $data['Organisme']['name'],
                                'firstname' => $data['Organisme']['name'],
                                'street' => $data['Organisme']['adresse'],
                                'ext' => $data['Organisme']['compl'],
                                'gsm' => $data['Organisme']['portable'],
                                'phone' => $data['Organisme']['tel'],
                                'country' => $data['Organisme']['pays' ]
                            )
                        );
                    }
                }
            }
        }
        
        return $dataForGRC;
    }

    
    /**
     * Pour obtenir l'état de la demande dans la GRC
     * @param type $data
     *  $data = array(
            'requete' => json_encode(
                array(
                    'id' => 1633315
                )
            )
        );
     * @return type
     */
    function getStatusGRC( $data ) {
        $this->lancerRequeteCurl('getstatusquery', null, $data);
        return $this->responseMessageStr;
    }

    
    /**
     * Pour mettre àjour l'état de la demande dans la GRC
     * @param type $data
            $data = array(
                'requete' => json_encode(
                    array(
                       'id' => 1606408,
                       'statusId' => 5
                    )
                )
            ); 
     * @return type
     */
    function updateStatusGRC( $data, $etat, $note ) {
        $this->lancerRequeteCurl('updatestatusquery', null, $data, $etat, $note);
        return $this->responseMessageStr;
    }
}

