<?php

/**
 * Activite model class
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Arnaud Auzolat
 * @copyright Initié par ADULLACT - Développé par Libriciel SCOP
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * @package		app
 * @subpackage		app.Model
 */
class Activite extends AppModel {

    /**
     *
     * @var type
     */
    public $name = 'Activite';

    /**
     *
     * @var type
     */
    public $useTable = 'activites';

    /**
     * hasMany
     *
     * @access public
     */
    public $hasMany = array(
        'Sousactivite' => array(
            'className' => 'Sousactivite',
            'foreignKey' => 'activite_id',
            'dependent' => false,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'exclusive' => null,
            'finderQuery' => null,
            'counterQuery' => null
        )
    );
    public $hasAndBelongsToMany = array(
        'Organisme' => array(
            'className' => 'Organisme',
            'joinTable' => 'activites_organismes',
            'foreignKey' => 'activite_id',
            'associationForeignKey' => 'organisme_id',
            'unique' => null,
            'conditions' => null,
            'fields' => null,
            'order' => null,
            'limit' => null,
            'offset' => null,
            'finderQuery' => null,
            'deleteQuery' => null,
            'insertQuery' => null,
            'with' => 'ActiviteOrganisme'
        )
    );
    public $validate = array(
        'name' => array(
            array(
                'rule' => array('notBlank'),
                'allowEmpty' => false,
            )
        )
    );

}

?>