<?php

App::uses('AppModel', 'Model');

/**
 * Ar model class
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * @package		app
 * @subpackage		app.Model
 */
class Ar extends AppModel {

    /**
     * Display field
     *
     * @var string
     */
    public $displayField = 'name';

    /**
     *
     * @var type
     */
    public $actsAs = array('Linkeddocs');

    /**
     * Validation rules
     *
     * @var array
     */
    public $validate = array(
        'name' => array(
            'notBlank' => array(
                'rule' => array('notBlank'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'size' => array(
            'numeric' => array(
                'rule' => array('numeric'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'courrier_id' => array(
            'numeric' => array(
                'rule' => array('numeric'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
    );

    //The Associations below have been created with all possible keys, those that are not needed can be removed

    /**
     * belongsTo associations
     *
     * @var array
     */
    public $belongsTo = array(
        'Courrier' => array(
            'className' => 'Courrier',
            'foreignKey' => 'courrier_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        )
    );

    
    /**
     *
     * @var type
     */
    public $otherMimeTypes = array(
        'audio' => array(
            'audio/x-wav' => 'wav',
            'audio/mpeg' => 'mp3',
            'application/ogg' => 'ogg',
            'audio/ogg' => 'ogg'
        ),
        'video' => array(
            'video/x-msvideo' => 'avi',
            'video/mpeg' => 'mpg',
            'video/mp4' => 'mp4',
            'application/ogg' => 'ogg',
            'video/ogg' => 'ogg'
        ),
        'image' => array(
            'image/gif' => 'gif',
            'image/jpeg' => 'jpg',
            'image/png' => 'png'
        ),
        'pdf' => array(
            'application/pdf' => 'pdf'
        )
    );
    public $convertibleMimeTypes = array(
        "application/vnd.oasis.opendocument.text",
        "application/vnd.oasis.opendocument.spreadsheet",
        "image/bmp",
        "image/tiff",
        "text/plain",
        "application/msword",
        "application/x-octetstream",
        "application/msexcel",
        "application/xls",
        "application/vnd.ms-office",
        "application/vnd.ms-excel",
        "application/rtf",
        "application/binary",
        "OCTET-STREAM"
    );

    /**
	 *
	 * @param type $id
	 * @return type
	 * @throws NotFoundException
	 */
	public function generatePreview($id = null, $path = null) {
		if (!empty($id)) {
            $this->id = $id;
        }

        if (empty($this->id)) {
            throw new NotFoundException();
        }

        $pdfContent = '';
        $fileContent = '';
        $this->recursive = -1;
        $ar = $this->read();

        $return = __d('document', 'Document.preview.error');
        if (!empty($path)) {
			//Conversion en pdf via Gedooo
			require_once 'XML/RPC2/Client.php';
            
            $content = file_get_contents($path);
            $options = array(
                'uglyStructHack' => true
            );
            $url = 'http://' . Configure::read('CLOUDOOO_HOST') . ':' . Configure::read('CLOUDOOO_PORT');
            $cli = XML_RPC2_Client::create($url, $options);

            $result = $cli->convertFile(base64_encode($content), 'odt', 'pdf', false, true);
            $pdfContent = base64_decode($result);
		} else {
            //Conversion en pdf via Gedooo
            if (in_array($ar['Ar']['mime'], $this->convertibleMimeTypes)) {
                require_once 'XML/RPC2/Client.php';
                $content = $ar['Ar']['content'];
                $options = array(
                    'uglyStructHack' => true
                );
                $url = 'http://' . Configure::read('CLOUDOOO_HOST') . ':' . Configure::read('CLOUDOOO_PORT');
                $cli = XML_RPC2_Client::create($url, $options);

                $result = $cli->convertFile(base64_encode($content), 'odt', 'pdf', false, true);
                $pdfContent = base64_decode($result);
            } else if ($ar['Ar']['mime'] == 'application/pdf' || $ar['Ar']['mime'] == 'PDF') {
                $pdfContent = $this->field('Ar.content', array('Ar.id' => $id));
            } else if ($ar['Ar']['mime'] == 'image/png' || $ar['Ar']['mime'] == 'image/jpeg') {
                // Si c'est une image, on retourne le contenu directement
                $return = $this->field('Ar.content', array('Ar.id' => $id));
            } else {
                require_once 'XML/RPC2/Client.php';
                
                $content = $ar['Ar']['content'];
                $options = array(
                    'uglyStructHack' => true
                );
                $url = 'http://' . Configure::read('CLOUDOOO_HOST') . ':' . Configure::read('CLOUDOOO_PORT');
                $cli = XML_RPC2_Client::create($url, $options);
                $result = $cli->convertFile(base64_encode($content), 'odt', 'pdf', false, true);
                $pdfContent = base64_decode($result);
                
            }
        }
        //Conversion en flash
        if (!empty($pdfContent)) {
            $return = $pdfContent;
        }


		return $return;
	}

}
