<?php

class CompositionsController extends CakeflowAppController {

    public $name = 'Compositions';
    public $helpers = array('Text', 'Cakeflow.Myhtml');
    public $components = array('Paginator', 'Cakeflow.VueDetaillee', 'DataAuthorized');

// Gestion des droits
//  public $commeDroit = array(
//      'index' => 'Circuits:index',
//      'edit' => 'Circuits:index',
//      'view' => 'Circuits:index',
//      'add' => 'Circuits:index',
//      'delete' => 'Circuits:index');
    //webgfc edit
//  public $components = array('DataAuthorized');

    public function index($etape_id = null) { // FIXME: Composition.etape_id
        $this->Connecteur = ClassRegistry::init('Connecteur');
        $parapheur = $this->Connecteur->find(
                'first', array(
            'conditions' => array(
                'Connecteur.name ILIKE' => '%Parapheur%'
            ),
            'contain' => false
                )
        );
        // lecture de l'étape
        $this->set('ariane', array('Administration', 'Gestion des circuits', 'Etapes', 'Compositions'));
        $this->{$this->modelClass}->Etape->Behaviors->attach('Containable');
        $etape = $this->Composition->Etape->find('first', array(
            'fields' => array('id', 'nom'),
            'contain' => array('Circuit.nom', 'Circuit.id'),
            'conditions' => array('Etape.id' => $etape_id)));

//        debug($etape);
        //webgfc edit
        $this->set('circuit_id', $etape['Circuit']['id']);

        if (!empty($etape)) {
            $this->paginate = array(
                'recursive' => -1,
                'fields' => array('id', 'type_validation', 'trigger_id', 'soustype'),
                'conditions' => array('Composition.etape_id' => $etape_id));
            $compositions = $this->Paginator->paginate('Composition');

            //Si le circuit est vide, rediriger vers la vue d'ajout d'étape
            if (empty($compositions) && stripos($this->previous, 'compositions/add') === false)
                $this->redirect(array('action' => 'add', $etape_id));


            // mise en forme pour la vue
            foreach ($compositions as $i => $data) {
                $compositions[$i][$this->modelClass]['typeValidationLibelle'] = $this->{$this->modelClass}->libelleTypeValidation($compositions[$i][$this->modelClass]['type_validation']);
                if ($compositions[$i][$this->modelClass]['trigger_id'] == -1) { //Cas d'une compo délégation parapheur
//                    $compositions[$i][$this->modelClass]['typeValidationLibelle'] .= " (" . Configure::read('IPARAPHEUR_TYPE') . " / " . $this->{$this->modelClass}->Etape->libelleSousType($compositions[$i][$this->modelClass]['soustype']) . ")";
                    $compositions[$i][$this->modelClass]['typeValidationLibelle'] .= " (" . $parapheur['Connecteur']['type'] . " / " . $this->{$this->modelClass}->Etape->libelleSousType($compositions[$i][$this->modelClass]['soustype'], $parapheur) . ")";
                }
                $compositions[$i][$this->modelClass]['triggerLibelle'] = $this->formatLinkedModel('Trigger', $compositions[$i][$this->modelClass]['trigger_id']);
            }

            // Peut-on ajouter une composition à cette étape ?
            $canAdd = $this->Composition->Etape->canAdd($etape_id);
            $this->set(compact('compositions', 'etape', 'canAdd'));
        } else {
            $this->Session->setFlash('Etape introuvable', 'growl');
            $this->redirect($this->referer());
        }
    }

    /**
     * Vue détaillée des compositions d'une étape
     */
    public function view($id = null) {
        // Données du connecteur
        $this->Connecteur = ClassRegistry::init('Connecteur');
        $parapheur = $this->Connecteur->find(
                'first', array(
            'conditions' => array(
                'Connecteur.name ILIKE' => '%Parapheur%'
            ),
            'contain' => false
                )
        );

        $this->set('ariane', array('Administration', 'Gestion des circuits', 'Etapes', 'Compositions', 'Vue détaillée d\'une composition'));
        $this->{$this->modelClass}->Behaviors->attach('Containable');
        $this->request->data = $this->{$this->modelClass}->find('first', array(
            'contain' => array(
                'Etape.id', 'Etape.nom', 'Etape.Circuit.nom'),
            'conditions' => array('Composition.id' => $id)));
        if (empty($this->request->data)) {
            $this->Session->setFlash(__('Invalide id pour la', true) . ' ' . __('composition', true) . ' : ' . __('affichage de la vue impossible.', true), 'growl', array('type' => 'important'));
            $this->redirect(array('action' => 'index'));
        } else {
            $this->pageTitle = Configure::read('appName') . ' : ' . __('Composition des Circuits de traitement', true) . ' : ' . __('vue d&eacute;taill&eacute;e', true);

            // préparation des informations à afficher dans la vue détaillée
            $maVue = new $this->VueDetaillee(
                    'Vue détaillée de la composition de l\'étape \'' . $this->request->data['Etape']['nom'] . '\' du circuit \'' . $this->request->data['Etape']['Circuit']['nom'] . '\'', __('Retour à la liste des compositions', true), array('action' => 'index', $this->request->data['Etape']['id']));
            $maVue->ajouteSection(__('Informations principales', true));
            $maVue->ajouteLigne(__('Identifiant interne (id)', true), $this->request->data[$this->modelClass]['id']);
            if ($this->request->data[$this->modelClass]['trigger_id'] == -1) {
                $maVue->ajouteLigne("Déclencheur", "Parapheur électronique");
            } else {
                $maVue->ajouteLigne(CAKEFLOW_TRIGGER_TITLE, $this->formatLinkedModel('Trigger', $this->request->data[$this->modelClass]['trigger_id']));
            }
            $maVue->ajouteLigne(__('Type', true), $this->{$this->modelClass}->libelleTypeValidation($this->request->data[$this->modelClass]['type_validation']));
            if ($this->request->data[$this->modelClass]['soustype'] != '')
                $maVue->ajouteLigne(__('Sous-Type', true), $this->{$this->modelClass}->Etape->libelleSousType($this->request->data[$this->modelClass]['soustype'], $parapheur));
//        $maVue->ajouteLigne(CAKEFLOW_TRIGGER_TITLE, $this->formatLinkedModel('Trigger', $this->request->data[$this->modelClass]['trigger_id']));
//        $maVue->ajouteLigne(__('Type', true), $this->{$this->modelClass}->libelleTypeValidation($this->request->data[$this->modelClass]['type_validation']));
            $maVue->ajouteSection(__('Création / Modification', true));
            $maVue->ajouteLigne(__('Date de cr&eacute;ation', true), $this->request->data[$this->modelClass]['created']);
            $maVue->ajouteElement(__('Par', true), $this->formatUser($this->request->data[$this->modelClass]['created_user_id']));
            $maVue->ajouteLigne(__('Date de dernière modification', true), $this->request->data[$this->modelClass]['modified']);
            $maVue->ajouteElement(__('Par', true), $this->formatUser($this->request->data[$this->modelClass]['modified_user_id']));

            $this->set('contenuVue', $maVue->getContenuVue());
        }
    }

    /**
     *
     */
    /* public function add($id) {
      if (!empty($this->request->data)) {
      $this->setCreatedModifiedUser($this->request->data);
      $this->Composition->create($this->request->data);
      if ($this->Composition->validates($this->request->data)) {
      if ($this->Composition->save()) {
      $this->Session->setFlash(__('Enregistrement effectué.', true), 'growl');
      } else {
      $this->Session->setFlash('Erreur lors de l\'enregistrement.', 'growl');
      }
      }
      $etape_id = $this->request->data['Composition']['etape_id'];
      } else {
      $canAdd = $this->Composition->Etape->canAdd($id);
      if (!$canAdd) {
      $this->Session->setFlash('Impossible d\'ajouter une composition à cette étape', 'growl');
      $this->redirect($this->referer());
      }
      $etape_id = $this->request->data['Composition']['etape_id'] = $id;
      }

      // lecture de la liste des déclencheurs
      //        $this->set('triggers', $this->listLinkedModel('Trigger'));

      //  WebGFC Edit
      $model = CAKEFLOW_TRIGGER_MODEL;
      $this->loadModel($model);
      $desktops = $this->DataAuthorized->getAuthDesktops(array('etapeId' => $id));
      $this->set('triggers', $desktops);
      // Récupération de la liste des services par bureau d'utilisateur sélectionné
      $this->loadModel('User');
      $listServices = array();
      foreach( $desktops as $key => $name ){
      $listServices[$key] = $this->User->Desktop->getServicesList($key);
      }
      $this->set('triggerServices', $listServices);
      // Fin WebGFC edit

      $this->set('typeValidations', $this->Composition->listeTypeValidation());
      $this->set('canAdd', $this->Composition->Etape->canAdd($etape_id));
      } */

    /**
     *
     */
    /* public function edit($id = null) {
      if (!empty($this->request->data)) {
      $this->setCreatedModifiedUser($this->request->data);
      $this->Composition->create($this->request->data);
      if ($this->Composition->validates($this->request->data)) {
      if ($this->Composition->save()) {
      $this->Session->setFlash(__('Enregistrement effectué.', true), 'growl');
      //                    $this->redirect(array('action' => 'index', $this->request->data['Composition']['etape_id']));
      } else {
      $this->Session->setFlash('Erreur lors de l\'enregistrement.', 'growl');
      }
      }
      $etape_id = $this->request->data['Composition']['etape_id'];
      } else {
      $this->request->data = $this->Composition->read(null, $id);
      $etape_id = $this->request->data['Composition']['etape_id'];
      }
      // lecture de la liste des déclencheurs
      //        $this->set('triggers', $this->listLinkedModel('Trigger'));
      //WebGFC Edit
      $triggers = array();
      $users = $this->User->find('all');
      foreach ($users as $user) {
      if ($user['User']['profil_id'] > 2 && $this->User->getCollectiviteId($user['User']['id']) == $this->Session->read('Auth.User.collectivite_id')) {
      $triggers[$user['User']['id']] = $user['User']['username'];
      }
      }
      $this->set('triggers', $triggers);
      $this->set('typeValidations', $this->Composition->listeTypeValidation());
      $this->set('canAdd', $this->Composition->Etape->canAdd($etape_id));
      } */

    /**
     *
     */
    function add($etape_id) {
        $this->set('ariane', array('Administration', 'Composition des circuits', 'Ajout de circuit'));
        $this->_add_edit($etape_id);
    }

    /**
     *
     */
    function edit($id = null) {
        $this->set('ariane', array('Administration', 'Composition des circuits', 'Edition du circuit'));
        $this->_add_edit($id);
    }

    /**
     *
     */
    public function _add_edit($id = null) {

        $this->Connecteur = ClassRegistry::init('Connecteur');
        $hasParapheurActif = $this->Connecteur->find(
            'first',
            array(
                'conditions' => array(
                    'Connecteur.name ILIKE' => '%Parapheur%'
                ),
                'contain' => false
            )
        );
        $this->set('hasParapheurActif', $hasParapheurActif);

        if (!empty($this->data)) {
            $this->setCreatedModifiedUser($this->request->data);
            if ($this->request->data['Composition']['type_composition'] == 'PARAPHEUR') {
                $this->Composition->Etape->id = $this->request->data['Composition']['etape_id'];
                $this->Composition->Etape->saveField('soustype', $this->request->data['Composition']['soustype']);
            } else
                $this->request->data['Composition']['soustype'] = NULL;

            $this->Composition->create($this->request->data);
            if ($this->Composition->validates($this->request->data)) {
                if ($this->Composition->save()) {
                    $this->Session->setFlash('Enregistrement effectué.', 'growl');
                    return $this->redirect(array('action' => 'index', $this->data['Composition']['etape_id']));
                } else {
                    $this->Session->setFlash('Erreur lors de l\'enregistrement.', 'growl');
                }
            }
            $etape_id = $this->data['Composition']['etape_id'];
        } else if ($this->action == 'edit') {

//            $this->request->data = $this->Composition->read(null, $id);
            $this->request->data = $this->Composition->find(
                'first',
                array(
                    'conditions' => array(
                        'Composition.id' => $id
                    ),
                    'contain' => false,
                    'recursive' => -1
                )
            );
//$this->log($this->request->data, LOG_ERROR);
//die();
            $etape_id = $this->request->data['Composition']['etape_id'];
//            $this->set('canAddParapheur', (Configure::read('USE_PARAPHEUR') && !$this->Composition->hasAny(array('etape_id' => $etape_id, 'trigger_id' => -1, 'id !=' => $id))));
            $this->set('canAddParapheur', ($hasParapheurActif['Connecteur']['use_signature'] && !$this->Composition->hasAny(array('etape_id' => $etape_id, 'trigger_id' => -1, 'id !=' => $id))));
            //WebGFC Edit
            //            //  WebGFC Edit
            $model = CAKEFLOW_TRIGGER_MODEL;
            $this->loadModel($model);
            $desktops = $this->DataAuthorized->getAuthDesktops(array('etapeId' => $etape_id));
            $this->set('triggers', $desktops);
            // Récupération de la liste des services par bureau d'utilisateur sélectionné
            $this->loadModel('User');
            $listServices = array();
            foreach ($desktops as $key => $name) {
                $listServices[$key] = $this->User->Desktop->getServicesList($key);
            }
            $this->set('triggerServices', $listServices);
            // Fin WebGFC edit
             $etape = $this->Composition->Etape->find('first', array(
                'fields' => array('circuit_id'),
                'conditions' => array('Etape.id' => $etape_id),
                'recursive' => -1));
            $this->set('circuit_id', $etape['Etape']['circuit_id']);
//            $triggers = array();
//            $this->loadModel('User');
//            $users = $this->User->find(
//                'all',
//                array(
//                    'recursive' => -1,
//                    'contain' => false
//                )
//            );
//            foreach ($users as $user) {
//debug($users);
//                if ($user['User']['profil_id'] > 2 && $this->User->getCollectiviteId($user['User']['id']) == $this->Session->read('Auth.User.collectivite_id')) {
//                    $triggers[$user['User']['id']] = $user['User']['username'];
//                }
//            }
//            $this->set('triggerServices', $triggers);
        } else if ($this->action == 'add') {
            $canAdd = $this->Composition->Etape->canAdd($id);
            if (!$canAdd) {
                $this->Session->setFlash('Impossible d\'ajouter une composition à cette étape', 'growl');
                return $this->redirect($this->referer());
            }
            $this->request->data['Composition']['etape_id'] = $id;
            $etape_id = $id;


            // Exsite-t-il un connecteur de type aprapheur
//            $this->set('canAddParapheur', (Configure::read('USE_PARAPHEUR') && !$this->Composition->hasAny(array('etape_id' => $id, 'trigger_id' => -1))));
            $this->set('canAddParapheur', ($hasParapheurActif['Connecteur']['use_signature'] && !$this->Composition->hasAny(array('etape_id' => $id, 'trigger_id' => -1))));

            //  WebGFC Edit
            $model = CAKEFLOW_TRIGGER_MODEL;
            $this->loadModel($model);
            $desktops = $this->DataAuthorized->getAuthDesktops(array('etapeId' => $id));
            $this->set('triggers', $desktops);
            // Récupération de la liste des services par bureau d'utilisateur sélectionné
            $this->loadModel('User');
            $listServices = array();
            foreach ($desktops as $key => $name) {
                $listServices[$key] = $this->User->Desktop->getServicesList($key);
            }
            $this->set('triggerServices', $listServices);
            // Fin WebGFC edit
            
            $etape = $this->Composition->Etape->find('first', array(
                'fields' => array('circuit_id'),
                'conditions' => array('Etape.id' => $id),
                'recursive' => -1));
            $this->set('circuit_id', $etape['Etape']['circuit_id']);
        }

        $this->set('typeCompositions', $this->Composition->listeTypes());

        // lecture de la liste des déclencheurs
//        $triggers = $this->listLinkedModel('Trigger');
//        $this->set('triggers', $triggers);
        $this->set('typeValidations', $this->Composition->listeTypeValidation());
        $this->set('canAdd', $this->Composition->Etape->canAdd($etape_id));
//        if (Configure::read('USE_PARAPHEUR')) {
        if ($hasParapheurActif['Connecteur']['use_signature']) {
//            $soustypes = $this->Composition->Etape->listeSousTypesParapheur();
            $soustypes = $this->Composition->Etape->listeSousTypesParapheur($hasParapheurActif);
//debug($hasParapheurActif);
//debug($soustypes);
            if (!empty($soustypes)) {
                $this->set('soustypes', $soustypes);
            } else {
                $this->Session->setFlash('Connexion au parapheur impossible', 'growl');
                $this->set('soustypes', array());
                $this->set('canAddParapheur', false);
            }
            /* try{
              $this->set('soustypes', $this->Composition->Etape->listeSousTypesParapheur());
              }catch(Exception $e){
              $this->Session->setFlash($e->getMessage(), 'growl');
              $this->set('soustypes', array());
              $this->set('canAddParapheur', false);
              } */
        }
        $this->render('add_edit');
    }

    /**
     *
     */
    public function delete($id = null) {
        if ($this->Composition->delete($id)) {
            $this->Session->setFlash(__('Suppression effectuée', true), 'growl');
        } else {
            $this->Session->setFlash('Erreur lors de la suppression', 'growl');
        }
        $this->autoRender = false;
//        $this->redirect($this->referer());
    }

}

?>
