<?php

App::uses('SimpleCommentAppModel', 'SimpleComment.Model');

/**
 * Carnet d'adresse
 *
 * SimpleComment Plugin
 * SimpleComment Comment model class
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 *
 * @package             SimpleComment
 * @subpackage          SimpleComment.Model
 *
 * @property Reader $Reader
 * @property Target $Target
 */
class SCCommentReader extends SimpleCommentAppModel {

    /**
     *
     * @var type
     */
    public $useTable = 'comments_readers';

    /**
     * Validation rules
     *
     * @var array
     */
    public $validate = array(
        'reader_id' => array(
            'numeric' => array(
                'rule' => array('numeric'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'comment_id' => array(
            'numeric' => array(
                'rule' => array('numeric'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
    );
    public $belongsTo = array(
        'Reader' => array(
            'className' => 'SimpleComment.SCReader',
            'foreignKey' => 'reader_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        ),
        'Comment' => array(
            'className' => 'SimpleComment.SCComment',
            'foreignKey' => 'comment_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        )
    );

}
