<?php

/**
 *
 * Courriers/get_infos.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
if (isset($viewOnly) && $viewOnly === true) {?>
    <?php echo $this->Element('viewOnly');?> 
    <script type="text/javascript">
        'use strict';
        var url = window.location.href;
        var urlCouper = url.split('/');
        var desktopcurrentId = urlCouper[urlCouper.length - 1];
        var fluxId = "<?php echo $flux['Courrier']['id'];?>";
        
        $('.detacheFlux').click(function () {
            swal({
                title: 'Détacher un flux',
                text: 'Vous voulez détacher ce flux depuis votre bannette de copie ? ',
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#d33",
                cancelButtonColor: "#3085d6",
                confirmButtonText: '<i class="fa fa-check" aria-hidden="true"></i> Valider',
                cancelButtonText: '<i class="fa fa-times-circle-o" aria-hidden="true"></i> Annuler',
            }).then(function (data) {
                if (data) {
                    window.location.href = "/courriers/detache/" + fluxId + '/' + desktopcurrentId;
                } else {
                    swal({
                        title: "Annulé!",
                        text: "Vous n\'avez pas détaché,;) .",
                        type: "error",
                        timer: 1500
                    });
                }
            });
        });
        
        $('.envoiCopieFlux').click(function () {
            gui.formMessage({
                title: '<?php echo __d('default', 'Button.send'); ?>',
                width: '600px',
                url: '/courriers/send/<?php echo $flux['Courrier']['id'] . '/1' ; ?>',
                buttons: {
                    "<?php echo __d('default', 'Button.submit'); ?>": function () {
                        var form = $(this).parents('.modal').find('form');
                        var url = '/courriers/send';
                        gui.request({
                            url: '/courriers/send/<?php echo $flux['Courrier']['id'] . '/1'; ?>',
                            data: form.serialize()
                        }, function (data) {
                            if (data.length > 4) { //FIXME avant avec 0 cela marchait
                                getJsonResponse(data);
                            } else {
                                window.location.href = "<?php echo Configure::read('BaseUrl') . "/environnement"; ?>";
                            }
                        });
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    },
                    "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                        $(this).parents(".modal").modal('hide');
                        $(this).parents(".modal").empty();
                    }
                }
            });
        });

    </script>
   <a href="#" title="<?php echo  __d('default', 'Button.detachcopie'); ?>"  alt="<?php echo  __d('default', 'Button.detachcopie'); ?>" style="float: right;" class="detacheFlux btn btn-info-webgfc btn-secondary"><i class="fa fa-unlock-alt" aria-hidden="true"></i></a> <a href="#" title="<?php echo  __d('default', 'Button.envoicopie'); ?>"  alt="<?php echo  __d('default', 'Button.envoicopie'); ?>" style="float: right;" class="envoiCopieFlux btn btn-info-webgfc btn-secondary"><i class="fa fa-paper-plane" aria-hidden="true"></i></a> <br />
    <?php
}

$priority = array(
    0 => array(
        'img' => $this->Html->image('/img/priority_low.png'),
        'txt' => __d('courrier', 'Courrier.priorite_0')
    ),
    1 => array(
        'img' => $this->Html->image('/img/priority_mid.png'),
        'txt' => __d('courrier', 'Courrier.priorite_1')
    ),
    2 => array(
        'img' => $this->Html->image('/img/priority_high.png'),
        'txt' => __d('courrier', 'Courrier.priorite_2')
    )
);

$direction = array(
    0 => array(
        'img' => '<i class="fa fa-sign-out" style="color:#e51809;" aria-hidden="true"></i>',
        'txt' => __d('courrier', 'Courrier.courrier_sortant'),
        'contact' => 'dest'
    ),
    1 => array(
        'img' => '<i class="fa fa-sign-in" style="color:#2ec07e;" aria-hidden="true"></i>',
        'txt' => __d('courrier', 'Courrier.courrier_entrant'),
        'contact' => 'exp'
    ),
    2 => array(
        'img' => '<i class="fa fa-level-up" style="color:#428bca;" aria-hidden="true"></i>',
        'txt' => __d('courrier', 'Courrier.courrier_interne'),
        'contact' => 'exp'
    )
);

$tabDelaiUnite = array('jour', 'semaine', 'mois');
?>
<div class="zone col-sm-12">
    <legend  ><i class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Courrier.fluxFieldset'); ?></legend>
    <div class="panel-body fieldsetView">
        <dl>
            <dt><?php echo __d('courrier', 'Courrier.name'); ?></dt>
            <dd><?php echo $flux['Courrier']['name']; ?></dd>
            <dt><?php echo __d('courrier', 'Courrier.origineflux_id'); ?></dt>
            <dd><?php echo $flux['Origineflux']['name']; ?></dd>
            <dt><?php echo __d('courrier', 'Courrier.objet'); ?></dt>
            <dd><?php echo $flux['Courrier']['objet']; ?></dd>
            <dt><?php echo __d('courrier', 'Courrier.priorite'); ?></dt>
            <dd>
                    <?php
                    echo $priority[$flux['Courrier']['priorite']]['img'] . " " . $priority[$flux['Courrier']['priorite']]['txt'];
                    ?>
            </dd>
            <dt><?php echo __d('courrier', 'Courrier.affairesuiviepar_id'); ?></dt>
            <dd><?php echo $flux['Affairesuivie']['name']; ?></dd>
        </dl>
    </div>
</div>


<div class="zone col-sm-12">
    <legend><i class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Qualification'); ?></legend>
    <div class="panel-body fieldsetView">
<?php if( Configure::read('Conf.SAERP')) :?>
    <?php if(!empty($flux['Pliconsultatif']["marche_id"]) && !empty($flux['Courrier']["typedocument"])): ?>
        <dl>
            <?php if(!empty($flux['Pliconsultatif']["marche_id"]) ):?>
            <dt ><?php echo __d('courrier', 'Courrier.marche_id'); ?></dt>
            <dd><?php echo $marches[$flux['Courrier']['marche_id']]; ?></dd>
            <?php endif;?>
            <?php if(!empty($flux['Courrier']["typedocument"]) ):?>
            <dt><?php echo __d('courrier', 'Courrier.typedocument'); ?></dt>
            <dd><?php echo $typesdocument[$flux['Courrier']['typedocument']]; ?></dd>
            <?php endif;?>
        </dl>
    <?php endif;?>
    <?php if($flux['Pliconsultatif']['id']!=null): ?>
        <dl id="pli">
            <?php /*if(!empty($flux['Pliconsultatif']["name"]) ):?>
                <dt ><?php echo __d('pliconsultatif', 'Pliconsultatif.name'); ?></dt>
                <dd><?php echo $flux['Pliconsultatif']['name']; ?></dd>
            <?php endif;*/?>
            <?php if(!empty($flux['Pliconsultatif']["origineflux_id"]) ):?>
            <dt ><?php echo __d('pliconsultatif', 'Pliconsultatif.origineflux_id'); ?></dt>
            <dd><?php echo $originesflux[$flux['Pliconsultatif']['origineflux_id']] ; ?></dd>
            <?php endif;?>
            <?php if(!empty($flux['Pliconsultatif']["numero"]) ):?>
            <dt ><?php echo __d('pliconsultatif', 'Pliconsultatif.numero'); ?></dt>
            <dd><?php echo $flux['Pliconsultatif']['numero']; ?></dd>
            <?php endif;?>
            <?php if(!empty($flux['Pliconsultatif']["objet"]) ):?>
            <dt ><?php echo __d('pliconsultatif', 'Pliconsultatif.objet'); ?></dt>
            <dd><?php echo $flux['Pliconsultatif']['objet'] ; ?></dd>
            <?php endif;?>
            <?php if(!empty($flux['Pliconsultatif']["date"]) ):?>
            <dt ><?php echo __d('pliconsultatif', 'Pliconsultatif.date'); ?></dt>
            <dd><?php echo $this->Html2->ukToFrenchDateWithSlashes($flux['Pliconsultatif']['date']).' à '.$flux['Pliconsultatif']['heure']; ?></dd>
            <?php endif;?>
        </dl>
    <?php endif; ?>
    <?php if($flux['Ordreservice']['id']!=null): ?>
        <dl id="os">
            <?php if(!empty($flux['Ordreservice']["name"]) ):?>
            <dt ><?php echo __d('ordreservice', 'Ordreservice.name'); ?></dt>
            <dd><?php echo $flux['Ordreservice']['name']; ?></dd>
            <?php endif;?>
            <?php if(!empty($flux['Ordreservice']["numero"]) ):?>
            <dt ><?php echo __d('ordreservice', 'Ordreservice.numero'); ?></dt>
            <dd><?php echo $flux['Ordreservice']['numero']; ?></dd>
            <?php endif;?>
            <?php if(!empty($flux['Ordreservice']["objet"]) ):?>
            <dt ><?php echo __d('ordreservice', 'Ordreservice.objet'); ?></dt>
            <dd><?php echo $flux['Ordreservice']['objet'] ; ?></dd>
            <?php endif;?>
            <?php if(!empty($flux['Ordreservice']["montant"]) ):?>
            <dt ><?php echo __d('ordreservice', 'Ordreservice.montant'); ?></dt>
            <dd><?php echo $flux['Ordreservice']['montant'] ; ?></dd>
            <?php endif;?>
        </dl>
    <?php endif; ?>
<?php endif;?>
        <dl>
            <dt><?php echo __d('type', 'Type'); ?></dt>
            <dd><?php echo (!empty($flux['Soustype']["type_id"]) ? $types[$flux['Soustype']['type_id']] : ""); ?></dd>
            <dt><?php echo __d('soustype', 'Soustype'); ?></dt>
            <dd><?php echo $flux['Soustype']['name']; ?></dd>
        </dl>

        <dl>
            <dt><?php echo __d('courrier', 'Courrier.reference'); ?></dt>
            <dd><?php echo $flux['Courrier']['reference']; ?></dd>
            <dt><?php echo __d('courrier', 'Courrier.entrant/sortant'); ?></dt>
            <dd>
                    <?php echo (isset($flux["Soustype"]['entrant']) ? $direction[$flux['Soustype']['entrant']]['img'] . " " . $direction[$flux['Soustype']['entrant']]['txt'] : ''); ?>
            </dd>
            <dt><?php echo __d('soustype', 'Soustype.delai'); ?></dt>
            <dd><?php echo (isset($flux['Courrier']['delai_nb']) && isset($flux['Courrier']['delai_unite'])) ? $flux['Courrier']['delai_nb'] . " " . $tabDelaiUnite[$flux['Courrier']['delai_unite']] . ((@$flux['Courrier']['delai_unite'] != 2 && $flux['Courrier']['delai_nb'] > 1) ? 's' : '' ) : @$flux['Soustype']['delai_nb'] . " " . @$tabDelaiUnite[$flux['Soustype']['delai_unite']] . ((@$flux['Soustype']['delai_unite'] != 2 && @$flux['Soustype']['delai_nb'] > 1) ? 's' : '' ); ?></dd>
        </dl>
    </div>
</div>

<div class="zone">
    <legend><i class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Acteurs'); ?></legend>
    <div class="panel-body form-horizontal fieldsetView">
        <table  id="acteursTable" data-toggle="table"  data-locale = "fr-CA" data-show-columns="true"> 
            <thead>
            <th><i class="fa fa-desktop" aria-hidden="true" title="Nom du bureau ayant traité le flux"></i></th>
            <th><i class="fa fa-user" aria-hidden="true" title="Nom de l'agent ayant traité le flux"></i></th>
            <th><i class="fa fa-id-card-o" aria-hidden="true" title="Rôle de l'agent ayant traité le flux"></i></th>
            <th><i class="fa fa-calendar-check-o" aria-hidden="true" title="Date d'arrivée chez l'agent"></i></th>
            <th><i class="fa fa-calendar-check-o" aria-hidden="true" title="Date de dernière modification"></i></th>
            <th><i class="fa fa-calendar-check-o" aria-hidden="true" title="Date de validation"></i></th>
            <th><i class="fa fa-files-o" aria-hidden="true"  title="Pour copie ?"></i></th>
            </thead>
            <tbody>
            <?php foreach( $bannettes as $key => $bannette ):?>
                <?php
                // Affichage de l'icône pour copie ou non
                    $bannetteName = $bannette['Bannette']['name'];
                    // Utilisateur ayant réalisé l'action
                    $user = @$bannette['Desktop']['User'][0]['nom'].' '.@$bannette['Desktop']['User'][0]['prenom'];
                    if( $user == ' ' ) {
                        $user = @$bannette['Desktop']['SecondaryUser'][0]['nom'].' '.@$bannette['Desktop']['SecondaryUser'][0]['prenom'];
                    }
                    
                    $gras = @$bannette['Bancontenu']['gras'];
                    if($gras) {
                        $val = 'bold';
                    }
                    else {
                        $val = 'thin';
                    }
                ?>
                <tr class="trCycle<?php echo $val;?>">
                    <td class="tdDate"><?php echo $bannette['Desktop']['name'];?></td>
                    <td class="tdDate"><?php echo $user;?></td>
                    <td class="tdDate"><?php echo $bannette['Desktop']['Profil']['name'];?></td>
                    <td class="tdDate"><?php echo strftime( '%d/%m/%Y %T', strtotime( $bannette['Bancontenu']['created'] ) );?></td>
                    <td class="tdDate"><?php echo !empty($bannette['Bancontenu']['modified']) ? strftime( '%d/%m/%Y %T', strtotime( $bannette['Bancontenu']['modified'] ) ) : '';?></td>
                    <td class="tdDate"><?php echo !empty($bannette['Bancontenu']['validated']) ? strftime( '%d/%m/%Y %T', strtotime( $bannette['Bancontenu']['validated'] ) ) : '';?></td>
                    <td class="tdState"><?php echo ($bannetteName == 'copy' ) ? $this->Html->image('/img/valid_16.png', array('alt' => 'Pour copie', 'title' => 'Flux envoyé pour copie' ) ) : null;?></td>
                </tr>
                        <?php endforeach;?>
            </tbody>
        </table>
    </div>
    <div style="margin-left: 15px;"><?php echo '<b>* Les lignes en gras représentent les agents possédant le flux actuellement.</b>';?></div>
</div>
   
<?php
    $contactInfos = "";
    if( !empty( $flux['Organisme']['name']) && empty($flux['Contact']["name"]) ) {
      $contactInfos = $flux['Organisme']["name"];
    }
    if( !empty( $flux['Organisme']['name']) && !empty($flux['Contact']["name"]) ) {
        $contactInfos = $flux['Organisme']["name"]. ' / '.$flux['Contact']["name"];
    }
    if( empty( $flux['Organisme']['name']) && !empty($flux['Contact']["name"]) ) {
        $contactInfos = $flux['Contact']["name"];
    }
    asort($civiliteOptions);
?>
<div class="panel panel-default fieldsetView">
    <div class="panel-heading">
        <h4 class="panel-title"><?php echo __d('courrier', 'Contactinfo'); ?></h4>
    </div>
    <div class="panel-body">
    <?php if(!empty($flux['Contact']['id']) ):?>
        <dt>Identité du contact</dt><dd><?php echo $contactInfos;?></dd>
        <dl class="col-sm-5">
            
            <dt class="strong">Nom / Prénom</dt>
            <dd class="tdField"><?php echo ( isset( $civiliteOptions[$flux['Contact']['civilite']] ) ? $civiliteOptions[$flux['Contact']['civilite']] : null  ).' '.$flux['Contact']['nom'].' '.$flux['Contact']['prenom'];?></dd>

            <dt class="strong"><?php echo __d('contact', 'Contact.numvoie');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['numvoie'];?></dd>

            <dt class="strong"><?php echo __d('contact', 'Contact.nomvoie');?></dt>
            <dd class="tdField"><?php echo !empty($flux['Contact']['banadresse']) ? $flux['Contact']['banadresse'] : $flux['Contact']['nomvoie'];?></dd>

            <dt class="strong"><?php echo __d('contact', 'Contact.compl');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['compl'];?></dd>
            <dt class="strong"><?php echo __d('contact', 'Contact.cp');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['cp'];?></dd>
            <dt class="strong"><?php echo __d('contact', 'Contact.ville');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['ville'];?></dd>
        </dl>
        <dl class="col-sm-5">                                   
            <dt class="strong"><?php echo __d('contact', 'Contact.name');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['name'];?></dd>

            <dt class="strong"><?php echo 'Adresse complète';?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['adressecomplete'];?></dd>

            <dt class="strong"><?php echo 'Pays';?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['pays'];?></dd>


            <dt class="strong"><?php echo __d('contact', 'Contact.tel');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['tel'];?></dd>
            <dt class="strong"><?php echo __d('contact', 'Contact.email');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['email'];?></dd>

            <dt class="strong"><?php echo __d('contact', 'Contact.role');?></dt>
            <dd class="tdField"><?php echo $flux['Contact']['role'];?></dd>

        </dl>
<?php else:?>
<?php echo $this->Html->tag('div', __d('addressbook', 'Contactinfo.void'), array('class' => 'alert alert-warning'));?>
<?php endif;?>
    </div>
</div>
<div class="zone col-sm-12">
    <legend  ><i class="fa fa-star-o" aria-hidden="true"></i> <?php echo __d('courrier', 'Courrier.dateFieldset'); ?></legend>
    <div class="panel-body fieldsetView">
        <dl>
            <dt><?php echo __d('courrier', 'Courrier.datereception'); ?></dt><dd><?php echo $this->Html2->ukToFrenchDateWithSlashes($flux['Courrier']['datereception']); ?></dd>
            <dt><?php echo __d('courrier', 'Courrier.date'); ?></dt><dd><?php echo $this->Html2->ukToFrenchDateWithSlashes($flux['Courrier']['date']); ?></dd>
        </dl>
    </div>
</div>

<script type="text/javascript">
    $("#acteursTable").bootstrapTable({});
    /*
     $(window).resize(function () {
     gestionWidthPanel();
     });
     gestionWidthPanel();
     
     function gestionWidthPanel() {
     if ($(window).width() < 1300) {
     $('#flux_infos .zone.col-sm-6').removeClass('col-sm-6').addClass('col-sm-11');
     $('#flux_infos .zone').css('min-height', '0px');
     } else {
     //            if ($('#cacheLateral i').hasClass('fa-undo')) {
     $('#flux_infos .zone.col-sm-11').removeClass('col-sm-12').addClass('col-sm-6');
     $('#flux_infos .zone').css('min-height', '350px');
     //            }
     }
     }
     */


    var jsContactinfo = $.parseJSON('<?php echo json_encode($contactinfosTreated, JSON_HEX_APOS); ?>');
    if (jsContactinfo != '') {
        $('#contactData').append(createContactinfo(jsContactinfo['Contactinfo']).css({'display': 'table', 'width': '100%', 'margin': '10px 0 10px -12px'}));
    }

    var jsOrganismeinfo = $.parseJSON('<?php echo json_encode($organismeTreated, JSON_HEX_APOS); ?>');
    if (jsOrganismeinfo != '') {
        $('#organismeData').append(createOrganismeinfo(jsOrganismeinfo['Organisme']).css({'display': 'table', 'width': '100%', 'margin': '10px 0 10px -12px'}));
    }

    $('.trCyclebold').css('font-weight', 'bold') ;
</script>