<?php

/**
 *
 * Desktops/set_deleg.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
echo $this->Html->script('formValidate.js', array('inline' => true));
?>
<script type="text/javascript">
    function reloadDelegPlanifiee(id) {
        gui.request({
            url: "/desktops/setDeleg/" + id,
            updateElement: $('#divRD'),
            loader: true,
            loaderMessage: gui.loaderMessage
        });
    }

</script>
<div class="panel" id ="divSetDelege" >
    <div class="panel-default">
        <div class ="panel-heading">
            <h4 class="panel-title">
                <?php echo __d('desktop', 'Desktop.Desktop') . ' : ' . $desktopName; ?>
            </h4>
        </div>
        <div class="panel-body">
            <div class="col-sm-5">
                <div class="delegEnCours">
                    <legend><?php echo __d('desktop', 'Desktop.deleg'); ?></legend>
                    <?php
                        if (!empty($userDesktopNameDelegated)) {
                            $ulContent = '';
                            foreach ($userDesktopNameDelegated as $desktopuser) {
                                $spanUnset = "";
                                $sameUser = ( $desktopuser['User']['id'] != $userSessionId) ? true : false;
                                $sameProfil = ( $userProfilSessionId == ADMIN_GID ) ? true : false;
                                $urlDelete = '/desktops/setDeleg/'. $desktopId . '/' . $desktopuser['User']['id'] . '/1';
                                if( $sameUser || $sameProfil || in_array($desktopuser['Desktop']['id'], $baseDesktops) ) {
                                    //TODO separer deux page, celui de admin modifier organisme, celui de mondifier compte infos
//                                    $imgUnset = $this->Html->image('/img/trash.png', array('url' => '/desktops/setDeleg/' . $desktopId . '/' . $desktopuser['User']['id'] . '/1', 'alt' => __d('deleg', 'Deleg.unset'), 'title' => __d('deleg', 'Deleg.unset')));
//                                    $spanUnset = $this->Html->tag('span', $imgUnset, array('class'=>'removeDelegeEnCours'));
                                    $spanUnset = "<span class='removeDelegeEnCours'><a href=$urlDelete><i class='btn fa fa-trash' aria-hidden='true' style='color:#E51809;' alt='Supprimer la délégation' title='Supprimer la délégation'></i> </a></span>";
                                }
                                $ulContent .= $this->Html->tag('li', $desktopuser['Desktop']['name'] . $spanUnset, array('class' => 'delegateToUser'));
                            }
                            echo  $this->Html->tag('ul', $ulContent, array('class' => 'delegateToUserList'));
                        } else {
                            echo  $this->Html->tag('div', __d('desktop', 'Desktop.deleg.void'), array('class' => 'alert alert-warning'));
                        }
                    ?>
                </div>
                <div class="delegPlan">
                    <legend><?php echo __d('desktop', 'Desktop.deleg.plan'); ?></legend>
                    <?php 
                    $time = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
                    if (!empty($plandelegations)) {
                        $ulContent = '';
                        foreach ($plandelegations as $plandelegation) {
                            $spanUnset = '';
                            $sameUser = ( $plandelegation['User']['id'] != $userSessionId ) ? true : false;
                            $sameProfil = ( $userProfilSessionId == ADMIN_GID ) ? true : false;
                            $tmp = explode(' ', $plandelegation['Plandelegation']['date_start']);
                            $tmp2 = explode('-', $tmp[0]);
                            $start = mktime(0, 0, 0, $tmp2[1], $tmp2[2], $tmp2[0]);
                            $urlPlanDelete = '/desktops/deleteDeleg/' . $plandelegation['Plandelegation']['id'];
                            $urlPlanEdit = '/desktops/editDeleg/' . $desktopId . '/' . $plandelegation['Plandelegation']['user_id'];
                            if (intval($start) - intval($time) > 0 ) {
                                if ( $sameUser || $sameProfil || in_array($plandelegation['Desktop']['id'], $baseDesktops)) {
                                // Suppression de la délégation supprimée
//                                    $imgUnset = $this->Html->image('/img/trash.png', array('url' => '/desktops/deleteDeleg/' . $plandelegation['Plandelegation']['id'], 'alt' => __d('deleg', 'Deleg.unset'), 'title' => __d('deleg', 'Deleg.unset'), 'class' => 'deleteDeleg'));
//                                    $spanUnset .= $this->Html->tag('span', $imgUnset, array( 'class' => 'deleteDeleg'));
                                    
                                    $spanUnset .= "<span class='deleteDeleg'><a href=$urlPlanDelete><i class='btn fa fa-trash' aria-hidden='true' style='color:#E51809;' alt='Supprimer la délégation' title='Supprimer la délégation'></i> </a></span>";
                                    $spanUnset .= "<span class='editDeleg'><a href=$urlPlanEdit><i class='btn fa fa-pencil' aria-hidden='true' style='color:#428bca;' alt='Modifier la délégation' title='Modifier la délégation'></i> </a></span>";
                                // Modification de la délagation planifiée
//                                    $imgEditset = $this->Html->image('/img/edit_16.png', array('url' => '/desktops/editDeleg/' . $desktopId . '/' . $plandelegation['Plandelegation']['user_id'], 'alt' => __d('deleg', 'Deleg.editDeleg'), 'title' => __d('deleg', 'Deleg.editDeleg'), 'class' => 'editDeleg'));
//                                    $spanUnset .= $this->Html->tag('span', $imgEditset, array( 'class' => 'editDeleg'));
                                    
                                }
                            } else {
                                $tmp = explode(' ', $plandelegation['Plandelegation']['date_end']);
                                $tmp2 = explode('-', $tmp[0]);
                                $end = mktime(0, 0, 0, $tmp2[1], $tmp2[2], $tmp2[0]);

                                if (intval($end) - intval($time) < 0) {
//                                   $spanUnset .= $this->Html->image('/img/valid_16.png', array('alt' => __d('desktop', 'Desktop.delegation.fullend'), 'title' => __d('desktop', 'Desktop.delegation.fullend'), 'class' => 'delegation_fullend'));
                                   $spanUnset .= "<span class='delegation_fullend'><i class='btn fa fa-check' style='color:#2ec07e;'aria-hidden='true' alt='Délégation terminée' title='Délégation terminée'></i> </span>";
                               } else {
                                    // Suppression de la délégation supprimée
//                                    $imgUnset = $this->Html->image('/img/trash.png', array('url' => '/desktops/deleteDeleg/' . $plandelegation['Plandelegation']['id'], 'alt' => __d('deleg', 'Deleg.unset'), 'title' => __d('deleg', 'Deleg.unset'), 'class' => 'deleteDeleg'));
//                                   $spanUnset .= $this->Html->tag('span', $imgUnset, array( 'class' => 'deleteDeleg'));

                                    
                                    $spanUnset .= "<span class='deleteDeleg'><a href=$urlPlanDelete><i class='btn fa fa-trash' aria-hidden='true' style='color:#E51809;' alt='Supprimer la délégation' title='Supprimer la délégation'></i> </a></span>";
                                    $spanUnset .= "<span class='editDeleg'><a href=$urlPlanEdit><i class='btn fa fa-pencil' aria-hidden='true' style='color:#428bca;' alt='Modifier la délégation' title='Modifier la délégation'></i> </a></span>";
                                    // Modification de la délagation planifiée
//                                   $imgEditset = $this->Html->image('/img/edit_16.png', array('url' => '/desktops/editDeleg/' . $desktopId . '/' . $plandelegation['Plandelegation']['user_id'], 'alt' => __d('deleg', 'Deleg.edit_deleg'), 'title' => __d('deleg', 'Deleg.edit_deleg'), 'class' => 'editDeleg'));
                                   
//                                   $spanUnset .= $this->Html->tag('span', $imgEditset, array( 'class' => 'editDeleg'));
                                   
                               }
                           }
                            $liContent = $this->Html->tag('div', $plandelegation['User']['Desktop']['name'] . $spanUnset);
                            $liContent .= $this->Html->tag('div', '(' . $this->Html2->ukToFrenchDateWithSlashes($plandelegation['Plandelegation']['date_start']) . ' - ' . $this->Html2->ukToFrenchDateWithSlashes($plandelegation['Plandelegation']['date_end']) . ')');
                            $ulContent .= $this->Html->tag('li', $liContent, array('class' => 'delegateToUser'));
                        }
                        echo  $this->Html->tag('ul', $ulContent, array('class' => 'delegateToUserList'));
                    } else {
                        echo $this->Html->tag('div', __d('desktop', 'Desktop.deleg.plan.void'), array('class' => 'alert alert-warning'));
                    }
                    ?>
                </div>
            </div>
            <div class="col-sm-6">
                <legend><?php echo __d('desktop', 'Desktop.deleg.add'); ?></legend>
                    <?php 
                    $formEditDeleg = array(
                        'name' => 'DesktopsUser',
                        'label_w' => 'col-sm-4',
                        'input_w' => 'col-sm-8',
                        'form_url' => array( 'controller' => 'desktops', 'action' => 'setDeleg',$desktopId),
                        'input' => array(
                            'DesktopsUser.desktop_id' => array(
                                'inputType' => 'hidden',
                                'items'=>array(
                                    'type'=>'hidden',
                                    'value'=>$desktopId
                                )
                            ),
                            'DesktopsUser.user_id' => array(
                                'labelText' => __d('user', 'Utilisateur'),
                                'inputType' => 'select',
                                'items'=>array(
                                    'type'=>'select',
                                    'options' => $chooseusers,
                                    'empty' => true,
                                    'required' => true
                                )
                            ),
                            'DesktopsUser.delegation' => array(
                                'inputType' => 'hidden',
                                'items'=>array(
                                    'type'=>'hidden',
                                    'value'=>true
                                )
                            ),
                            'DesktopsUser.planification' => array(
                                'labelText' =>__d('desktop', 'Desktop.delegation.planification.active'),
                                'inputType' => 'checkbox',
                                'items'=>array(
                                    'type'=>'checkbox'
                                )
                            )
                        )
                    );
                    $formEditDelegPlannifier = array(
                        'name' => 'DesktopsUser',
                        'label_w' => 'col-sm-4',
                        'input_w' => 'col-sm-6',
                        'form_url' => array( 'controller' => 'desktops', 'action' => 'setDeleg',$desktopId),
                        'input' => array(
                            'DesktopsUser.date_start' => array(
                                'labelText' =>__d('desktop', 'Desktop.deleg.datestart'),
                                'inputType' => 'text',
                                'dateInput' =>true,
                                'items'=>array(
                                    'type'=>'text'
                                )
                            ),
                            'DesktopsUser.date_end' => array(
                                'labelText' =>__d('desktop', 'Desktop.deleg.dateend'),
                                'inputType' => 'text',
                                'dateInput' =>true,
                                'items'=>array(
                                    'type'=>'text'
                                )
                            )
                        )
                    );
                ?>
                <div class="newDeleg">                    
                    <?php echo $this->Formulaire->createForm($formEditDeleg); ?>
                    <div class="infoPlan" id="fieldsetPlan">
                        <?php echo $this->Formulaire->createForm($formEditDelegPlannifier); ?>
                    </div>
                    <?php echo $this->Form->end(); ?>
                </div>
            </div>
        </div>
        <?php if(isset($admin) && $admin):?>
        <div class="panel-footer controls delegFooter  " role="group"></div>
        <?php endif ?>
    </div>
</div>

<script type="text/javascript">
    function showPlanification() {
        if ($('#DesktopsUserPlanification').prop("checked")) {
            $('#fieldsetPlan').css("display", "block");
        } else {
            $('#fieldsetPlan').css("display", "none");
        }
    }
    
    $('.form_datetime input').datepicker({
        language: 'fr-FR',
        format: "dd/mm/yyyy",
        weekStart: 1,
        autoclose: true,
        todayBtn: 'linked'
    });

    gui.addbuttons({
        element: $('.panel-footer.delegFooter'),
        buttons: [
            {
                content: "<?php echo __d('default', 'Button.submit'); ?>",
                class: "btn-success",
                action: function () {
                    if (form_validate($('#DesktopsUserSetDelegForm'))) {
                        var updateElement = $('.divRD');
                        if (updateElement.length == 0) {
                            updateElement = $('.ui-dialog-content');
                        }
                        var url = $('#DesktopsUserSetDelegForm').attr('action');
                        gui.request({
                            url: url,
                            data: $('#DesktopsUserSetDelegForm').serialize(),
                            loader: true,
                            updateElement: updateElement,
                            loaderMessage: gui.loaderMessage
                        }, function (data) {
                            getJsonResponse(data);
                            gui.request({
                                url: url,
                                loader: true,
                                updateElement: updateElement,
                                loaderMessage: gui.loaderMessage
                            }, function (data) {
                                updateElement.html(data);
                                reloadDelegDependances();
                            });
                        });
                        $("#divSetDelege").remove();
                        $("#habilsPerson").show();
                    } else {
                        swal({
                            title: "Oops...",
                            text: "Veuillez vérifier votre formulaire!",
                            type: "error",
                            timer: 1500
                        });
                    }
                }

            },
            {
                content: "<?php echo __d('default', 'Button.cancel'); ?>",
                class: "btn-danger",
                action: function () {
                    $("#divSetDelege").remove();
                    $("#habilsPerson").show();
                }
            }
        ]
    });

    $('#DesktopsUserSetDelegForm input[type=submit]').remove();
    $('.delegateToUser span.removeDelegeEnCours').each(function () {
        var container = $(this);
        var link = $('a', container);
        var url = link.attr('href');
        var img = $('i', container);

        container.append(img);
        link.remove();

        var updateElement = $('.container');
        if (updateElement.length == 0) {
            updateElement = $('.modal-body');
        }
        img.button().click(function () {
            swal({
                title: "<?php echo __d('default', 'Modal.suppressionTitle'); ?>",
                text: "<?php echo __d('default', 'Modal.suppressionContents'); ?>",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#d33',
                cancelButtonColor: '#3085d6',
                confirmButtonText: "<?php echo __d('default', 'Button.valid'); ?>",
                cancelButtonText: "<?php echo __d('default', 'Button.cancel'); ?>",
            }).then(function (data) {
                if (data) {
                    gui.request({
                        url: url,
                        loader: true,
                        updateElement: updateElement,
                        loaderMessage: gui.loaderMessage
                    }, function (data) {
                        <?php if(isset($admin) && $admin){ ?>
                        loadHabilis();
                        $("#habilsPerson").show();
                        <?php }else{ ?>
                        window.location.href = "<?php echo Configure::read('BaseUrl') . "/users/getInfosCompte"; ?>";
                        <?php } ?>
                    });
                } else {
                    swal({
                        title: "Annulé!",
                        text: "Vous n'avez pas supprimé, ;) .",
                        type: "error",
                        timer: 1500
                    });
                }
            });
        });
    });

    $('.delegateToUser span.deleteDeleg').each(function () {
        var container = $(this);
        var link = $('a', container);
        var url = link.attr('href');
        var img = $('i', container);
        container.append(img);
        link.remove();


        var updateElement = $('.container');
        if (updateElement.length == 0) {
            updateElement = $('.modal-body');
        }
        img.button().click(function () {
            swal({
                title: "<?php echo __d('default', 'Modal.suppressionTitle'); ?>",
                text: "<?php echo __d('default', 'Modal.suppressionContents'); ?>",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#d33',
                cancelButtonColor: '#3085d6',
                confirmButtonText: "<?php echo __d('default', 'Button.valid'); ?>",
                cancelButtonText: "<?php echo __d('default', 'Button.cancel'); ?>",
            }).then(function (data) {
                if (data) {
                    gui.request({
                        url: url,
                        loader: true,
                        updateElement: updateElement,
                        loaderMessage: gui.loaderMessage
                    }, function (data) {
                        <?php if(isset($admin) && $admin){ ?>
                        loadHabilis();
                        $("#habilsPerson").show();
                        <?php }else{ ?>
                            window.location.href = "<?php echo Configure::read('BaseUrl') . "/users/getInfosCompte"; ?>";
                        <?php } ?>
                    });
                } else {
                    swal({
                        title: "Annulé!",
                        text: "Vous n'avez pas supprimé, ;) .",
                        type: "error",
                        timer: 1500
                    });
                }
            });
        });
    });

    $('#DesktopsUserPlanification').change(function () {
        showPlanification();
    })

    showPlanification();

    $('#DesktopsUserUserId').select2();



    $('.delegateToUser span.editDeleg').each(function () {

        var container = $(this);
        var link = $('a', container);
        var url = link.attr('href');
        var img = $('i', container);

        container.append(img);
        link.remove();

        <?php if(isset($admin) && $admin){ ?>
        url = url + "/admin";
        <?php } ?>

        var updateElement = $('.divRD');
        if (updateElement.length == 0) {
            updateElement = $('.ui-dialog-content');
        }
        img.button().click(function () {
            var form = $(this).parents('.modal').find('form');
            gui.formMessage({
                updateElement: $('body'),
                loader: true,
                width: '550px',
                loaderMessage: gui.loaderMessage,
                title: 'Modification de la délégation',
//                data: $(form).serialize(),
                url: url,
                buttons: {
                    "<?php echo __d('default', 'Button.submit'); ?>": function () {    
                        var url = '/desktops/editDeleg/<?php echo $desktopId; ?>/<?php echo $userId; ?>';
                        if (form_validate($('#PlandelegationEditDelegForm'))) {
                            gui.request({
                                url: url,
                                data: $('#PlandelegationEditDelegForm').serialize(),
                                loaderElement: $('#PlandelegationEditDelegForm'),
                                loaderMessage: gui.loaderMessage
                            }, function (data) {
                                gui.request({
                                    url: '/desktops/setDeleg/<?php echo $desktopId; ?>',
                                    loader: true,
                                    updateElement: $('.delegPlan' ),
                                }, function (data) {
                                    layer.msg('Les informations ont été enregistrées', {});
                                    $('.modal-content #edit_deleg_footer').remove();
//                                    $('.modal-body').remove();
                                    $('.modal-footer').show();
                                    $('.model-body' ).html(data);
                                });
                            });
                            $(this).parents('.modal').modal('hide');
                            $(this).parents('.modal').empty();
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    },
                    "<?php echo __d('default', 'Button.cancel'); ?>": function () {
                        $(this).parents('.modal').modal('hide');
                        $(this).parents('.modal').empty();
                    }
                }
            });
            
            
            
//            gui.request({
//                url: url,
//                loader: true,
//                updateElement: $('body'),
//                loaderMessage: gui.loaderMessage
//            }, function (data) {
//                <?php /*if(isset($admin) && $admin){ ?>
//                $("#divSetDelege").find('.panel-body').html(data);
//                <?php }else{ ?>
//                $('.modal-body').html(data);
//                <?php } */?>
//
//            });
        });
    });

</script>