<?php

/**
 *
 * Dossiers/get_dossiers.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php
if (!empty($dossiers)) {
    $options = array(
        'nodes' => array(
            array(
                'model' => 'Dossier',
                'field' => 'name',
                'actions' => array(
                    "edit" => array(
                        "ico" => 'fa fa-pencil',
                        "url" => '/dossiers/edit',
                        "updateElement" => "$('#infos .content')",
                        "formMessage" => false,
//                        "icoColor" => "#428bca"
                    ),
                    "delete" => array(
                        "ico" => 'fa fa-trash',
                        "url" => '/dossiers/delete',
                        "updateElement" => "$('#infos .content')",
                        "refreshAction" => "loadStructure();",
//                        "icoColor" => "#FF0000"
                    )
                )
            ),
            array(
                'model' => 'Affaire',
                'field' => 'name',
                'actions' => array(
                    "edit" => array(
                        "ico" => 'fa fa-pencil',
                        "url" => '/affaires/edit',
                        "updateElement" => "$('#infos .content')",
                        "formMessage" => false,
//                        "icoColor" => "#428bca"
                    ),
                    "delete" => array(
                        "ico" => 'fa fa-trash',
                        "url" => '/affaires/delete',
                        "updateElement" => "$('#infos .content')",
                        "refreshAction" => "loadStructure();",
//                        "icoColor" => "#FF0000"
                    )
                )
            )
        ),
        'listId' => 'browser',
        'listClass' => 'filetree'
    );
    echo $this->Html->tag('a','<i class="fa fa-window-maximize" aria-hidden="true" ></i>',array('class'=>'btn btn-info-webgfc toggle-pile','escape'=>false,'style'=>'margin:10px 0 0 15px;','title'=>"Tout déplier"));
    echo "<div class='action-title btn-group pull-right' style='margin:10px 15px auto auto '></div>";
    echo $this->Liste->jqueryTreeView($dossiers, $options);
} else {
    echo $this->Html->div('alert alert-warning',__d('dossier', 'Dossier.void'));
}
?>

<script type="text/javascript">
    $('#liste .folder').removeClass('ui-state-focus');
    $("#browser").treeview({collapsed: true});
    $('.treeviewBttn i').each(function () {
        var parentSpan = $(this).parent().parent();
        var parentLink = $(this).parent();
        var href = $(this).parent().attr('href');
        var img = $(this).detach();
        img.appendTo(parentSpan).click(function () {
            if ($(this).hasClass('editBttn')) {
                $('#infos').modal('show');
                gui.request({
                    url: href,
                    updateElement: $('#infos .content'),
                    loader: true,
                    loaderMessage: gui.loaderMessage
                });
            }
            if ($(this).hasClass('deleteBttn')) {
                var alert = '<br/> Attention: Si vous supprimez un dossier contenant des affaires, les affaires ne seront pas supprimées mais automatiquement transférées dans le répertoire "Affaires hors dossier"! ';
                swal({
                    title: "<?php echo __d('default', 'Modal.suppressionTitle'); ?>",
                    text: "<?php echo __d('default', 'Modal.suppressionContents'); ?>" + alert,
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#d33',
                    cancelButtonColor: '#3085d6',
                    confirmButtonText: "<?php echo __d('default', 'Button.valid'); ?>",
                    cancelButtonText: "<?php echo __d('default', 'Button.cancel'); ?>",
                }).then(function (data) {
                    if (data) {
                        gui.request({
                            url: href,
                            updateElement: $('#webgfc_content'),
                            loader: true,
                            loaderMessage: gui.loaderMessage
                        }, function (data) {
                            getJsonResponse(data);
                            loadDossiersAffaires();
                        });
                    } else {
                        swal({
                            title: "Annulé!",
                            text: "Vous n'avez pas supprimé, ;) .",
                            type: "error",
                            timer: 1500
                        });
                    }
                });
            }
        });
        parentLink.remove();
    });

//Pouvoir tout déplier/replier d'un clic
    $(".toggle-pile").click(function () {
        var btn = $(this).find('i');
        var link = $(this);
        $('.hitarea').each(function () {
            var bg = $(this).css('background-image');
            if (bg.indexOf('arrow-right') > 0 && btn.hasClass('fa-window-maximize')) {
                $(this).click();
            } else if (bg.indexOf('arrow-down') > 0 && btn.hasClass('fa-window-minimize')) {
                $(this).click();
            }
        });
        if (btn.hasClass('fa-window-maximize')) {
            btn.removeClass('fa-window-maximize').addClass('fa-window-minimize');
            link.prop('title', 'Tout plier');
        }
        else if (btn.hasClass('fa-window-minimize')) {
            btn.removeClass('fa-window-minimize').addClass('fa-window-maximize');
            link.prop('title', 'Tout déplier');
        }
    });
</script>