<?php

/**
 *
 * Marche/index.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Arnaud AUZOLAT
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php 
//echo $this->Html->css(array('administration'), null, array('inline' => false));  
echo $this->Html->script('formValidate.js', array('inline' => true));
?>

<script type="text/javascript">
    function loadMarche() {
        $('#infos .content').empty();

        gui.request({
            url: "<?php echo Configure::read('BaseUrl') . "/marches/getMarches"; ?>",
            updateElement: $('#liste .content'),
            loader: true,
            loaderMessage: gui.loaderMessage
        });


    }
</script>

<div class="container">
    <div id="liste" class="row">
        <div  class="table-list">
            <h3><?php echo __d('marche', 'Marche.liste'); ?></h3>
            <div class="content">
            </div>
        </div>
        <div class="controls panel-footer " role="group">
        </div>
    </div>
</div>

<div id="infos" class="modal fade " role="dialog">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="panel">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h4 class="panel-title"><?php echo __d('marche', 'Marche.infos'); ?></h4>
                    </div>
                    <div class="panel-body content">
                    </div>
                    <div class="panel-footer controls " role="group">
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


<script type="text/javascript">

    gui.buttonbox({
        element: $('#liste .controls')
    });

<?php if( !empty($operations) ):?>
    gui.addbutton({
        element: $('#liste .controls'),
        class: 'btn  btn-info-webgfc',
        button: {
            content: '<i class="fa fa-plus-circle" aria-hidden="true"></i> Ajouter un marché',
            title: "<?php echo __d('default', 'Button.add'); ?>",
            action: function () {
                $('#infos').modal('show');
                gui.request({
                    url: "<?php echo Configure::read('BaseUrl') . "/marches/add"; ?>",
                    updateElement: $('#infos .content'),
                    loader: true,
                    loaderMessage: gui.loaderMessage
                });
            }
        }
    });
<?php else :?>
    gui.addbutton({
        element: $('#liste .controls'),
        class: 'btn  btn-info-webgfc',
        button: {
            content: '<i class="fa fa-plus-circle" aria-hidden="true"></i> Ajouter un marché',
            title: "<?php echo __d('default', 'Button.add'); ?>",
            action: function () {
                var title = <?php echo __d('marche', 'Marche.forbidden'); ?>;
                var text = <?php echo __d('marche', 'Marche.add.forbidden'); ?>;
                swal(
                        'Oops...',
                        title + "<br>" + text,
                        'warning'
                        );
            }
        }
    });

    gui.disablebutton({
        element: $('#liste .controls'),
        button: '<i class="fa fa-plus-circle" aria-hidden="true"></i> Ajouter un marché',
    });
<?php endif;?>


    gui.buttonbox({
        element: $('#infos .controls'),
        align: "center"
    });

    gui.addbuttons({
        element: $('#infos .controls'),
        buttons: [
            {
                content: "<?php echo __d('default', 'Button.submit'); ?>",
                class: "btn-success ",
                action: function () {
                    var forms = $(this).parents('.modal').find('form');
                    $.each(forms, function (index, form) {
                        var url = form.action;
                        var id = form.id;
                        if (form_validate($('#' + id))) {
                            gui.request({
                                url: url,
                                data: $('#' + id).serialize()
                            }, function (data) {
                                getJsonResponse(data);
                                loadMarche();
                            });
                            $(this).parents('.modal').modal('hide');
                        } else {
                            swal({
                                title: "Oops...",
                                text: "Veuillez vérifier votre formulaire!",
                                type: "error",
                                timer: 1500
                            });
                        }
                    });
                }
            },
            {
                content: "<?php echo __d('default', 'Button.cancel'); ?>",
                class: "btn-danger ",
                action: function () {
                    $('#infos').modal('hide');
                }
            }
        ]
    });



    loadMarche();

    gui.addbutton({
        element: $('#liste .controls'),
        button: {
            content: '<i class="fa fa-download" aria-hidden="true"></i> Télécharger les résultats',
            title: "<?php echo __d('default', 'Button.exportmarche'); ?>",
            class: 'btn  btn-info-webgfc export_marches',
            action: function () {
                window.location.href = "<?php echo Router::url( array( 'controller' => 'marches', 'action' => 'export' ) + Hash::flatten( $this->request->data, '__' ) );?>";
            }
        }
    });
</script>



