<?php

/**
 *
 * Pliconsultatifs/add.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Arn aud AUZOLAT
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<div class="row">
    <div class="panel panel-default">
        <div class="panel-heading">
            <h4 class="panel-title"><?php echo __d('pliconsultatif', 'Pliconsultatif.newPlis'); ?></h4>
        </div>
        <div class="panel-body">
        <?php

            $formPlisconsultatifs = array(
                'name' => 'Pliconsultatif',
                'label_w' => 'col-sm-4',
                'input_w' => 'col-sm-5',
                'input' => array(
                    'Pliconsultatif.origineflux_id' => array(
                        'labelText' =>__d('pliconsultatif', 'Pliconsultatif.origineflux_id'),
                        'inputType' => 'select',
                        'items'=>array(
                            'type' => 'select', 
                            'empty' => true, 
                            'options' => $origineflux
                        )
                    ),
                    'Pliconsultatif.numero' => array(
                        'labelText' =>__d('pliconsultatif', 'Pliconsultatif.numero'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text',
                            'required'=>true,
                            'value' => $numeroPli
                        )
                    ),
                    'Pliconsultatif.objet' => array(
                        'labelText' =>__d('pliconsultatif', 'Pliconsultatif.objet'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    ),
                    'Pliconsultatif.date' => array(
                        'labelText' =>__d('pliconsultatif', 'Pliconsultatif.date'),
                        'inputType' => 'text',
                        'dateInput' =>true,
                        'items'=>array(
                            'type'=>'text',
                            'readonly' => true,
                            'class' => 'datepicker',
                            'data-format'=>'dd/MM/yyyy'
                        )
                    ),
                    'Pliconsultatif.heure' => array(
                        'labelText' =>__d('pliconsultatif', 'Pliconsultatif.heure'),
                        'inputType' => 'time',
                        'items'=>array(
                            'type' => 'time', 
                            'timeFormat' => '24', 
                            'interval' => 05, 
                            'empty' => true,
                            'required'=>false
                        )
                    ),
                    'Pliconsultatif.lot' => array(
                        'labelText' =>__d( 'pliconsultatif', 'Pliconsultatif.lot'),
                        'inputType' => 'text',
                        'items'=>array(
                            'type'=>'text'
                        )
                    ),
                    'Pliconsultatif.consultation_id' => array(
                        'inputType' => 'hidden',
                        'items'=>array(
                            'type'=>'hidden',
                            'value' => $this->request->params['pass'][0]
                        )
                    )
                )
            );

            echo $this->Formulaire->createForm($formPlisconsultatifs);
            echo $this->Form->end();
        ?>
        </div>
        <div class="panel-footer controler " role="group">
            <a id="valid" class="btn btn-success "><i class="fa fa-floppy-o" aria-hidden="true"></i> Enregistrer</a>
            <a id="cancel" class="btn btn-danger "><i class="fa fa-times-circle-o" aria-hidden="true"></i> Annuler</a>
        </div>
    </div>
</div>
<script type="text/javascript">

    $(document).ready(function () {
        $('.form_datetime input').datepicker({
            language: 'fr-FR',
            format: "dd/mm/yyyy",
            weekStart: 1,
            autoclose: true,
            todayBtn: 'linked'
        });

    });

    $('#PliconsultatifNumero').change(function () {
        var marcheid = "<?php echo $this->request->params['pass'][0];?>";
        gui.request({
            url: "/plisconsultatifs/ajaxformdata/numero/" + marcheid,
            data: $('#PliconsultatifAddForm').serialize()
        }, function (data) {
            processJsonFormCheck(data);
        });
    });

    $('#PliconsultatifOriginefluxId').select2({allowClear: true, placeholder: "Sélectionner un mode de réception"});
    $('#PliconsultatifHeureHour').select2({allowClear: true});
    $('#PliconsultatifHeureMin').select2({allowClear: true});


    $('#s2id_PliconsultatifHeureHour').css({
        width: '48%',
        float: 'left'
    });

    $('#s2id_PliconsultatifHeureMin').css({
        width: '48%',
        float: 'right'
    });

    $('#valid').click(function () {
        var url = "<?php echo Router::url(array('controller' => 'plisconsultatifs', 'action' => 'add', $consultationId)); ?>";
        var form = $(this).parents('.modal').find('form');
        if (form_validate(form)) {
            gui.request({
                url: url,
                data: form.serialize()
            }, function (data) {
                loadValues();
            });
            affichageTab();
        } else {
            swal({
                title: "Oops...",
                text: "Veuillez vérifier votre formulaire!",
                type: "error",
                timer: 1500
            });
        }

    });
    $('#cancel').click(function () {
        loadValues();
        affichageTab();
    });
</script>




