<?php

/**
 *
 * Collectivites/scanemail_add.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Arn aud AUZOLAT
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php
echo $this->Html->script('formValidate.js', array('inline' => true));
?>
<?php
$formScanemail = array(
        'name' => 'Scanemail',
        'label_w' => 'col-sm-5',
        'input_w' => 'col-sm-6',
        'input' => array(
            'Scanemail.scriptname' => array(
                'labelText' => __d('scanemail', 'Scanemail.scriptname'),
                'inputType' => 'text',
                'labelPlaceholder' =>__d('scanemail', 'Scanemail.placeholderScriptnameAdd'),
                'items'=>array(
                    'type'=>'text',
                    'required'=>true
                )
            ),
            'Scanemail.name' => array(
                'labelText' =>__d('scanemail', 'Scanemail.name'),
                'inputType' => 'text',
                'labelPlaceholder' =>__d('scanemail', 'Scanemail.placeholderNameAdd'),
                'items'=>array(
                    'type'=>'text',
                    'required'=>true
                )
            ),
            'Scanemail.mail' => array(
                'labelText' =>__d('scanemail', 'Scanemail.mail'),
               'inputType' => 'email',
                'items'=>array(
                    'type'=>'email',
                )
            ),
            'Scanemail.username' => array(
                'labelText' =>__d('scanemail', 'Scanemail.username'),
                'inputType' => 'text',
                'items'=>array(
                    'type'=>'text',
                    'required'=>true
                )
            ),
            'Scanemail.password' => array(
                'labelText' =>__d('scanemail', 'Scanemail.password'),
                'inputType' => 'password',
                'items'=>array(
                    'type'=>'password',
                    'required'=>true
                )
            ),
            'Scanemail.hostname' => array(
                'labelText' =>__d('scanemail', 'Scanemail.hostname'),
                'inputType' => 'text',
                'items'=>array(
                    'type'=>'text',
                    'required'=>true
                )
            ),
            'Scanemail.port' => array(
                'labelText' =>__d('scanemail', 'Scanemail.port'),
                'inputType' => 'number',
                'items'=>array(
                    'type'=>'number',
                    'required'=>true,
                    'min'=>0
                )
            ),
            'Scanemail.desktopmanager_id' => array(
                'labelText' =>__d('scanemail', 'Scanemail.desktop_id'),
                'inputType' => 'select',
                'items'=>array(
                    'options' => $listDesktopsManagers,
                    'type'=>'select',
                    'empty' => true,
                    'required'=>true
                )
            ),
            'Scanemail.type_id' => array(
                'labelText' =>__d('scanemail', 'Scanemail.type_id'),
                'inputType' => 'select',
                'items'=>array(
//                    'options' => array(),
                    'options' => $types,
                    'type'=>'select',
                    'empty' => true,
                )
            ),
            'Scanemail.soustype_id' => array(
                'labelText' =>__d('scanemail', 'Scanemail.soustype_id'),
                'inputType' => 'select',
                'items'=>array(
                    'options' => array(),
                    'type'=>'select',
                    'empty' => true
                )
            )
        )
    );
    echo $this->Formulaire->createForm($formScanemail);
    echo $this->Form->end();
?>

<script type="text/javascript">
//    $('#ScanemailDesktopId').select2();
    $('#ScanemailDesktopmanagerId').select2({allowClear: true, placeholder: "Sélectionner un bureau"});
    $("#ScanemailTypeId").select2();
    $("#ScanemailSoustypeId").select2();

    //contruction du tableau de types / soustypes
    $('#ScanemailTypeId').change(function () {
        var typeChoix = new Array();
        typeChoix.push($('#ScanemailTypeId').val());
        chargeSoustypes(typeChoix);
    });
    function chargeSoustypes(types) {
        $.ajax({
            type: 'post',
            url: '/recherches/charge_soustypes',
            data: {TypeChoix: types},
            success: function (data) {
                $('#ScanemailSoustypeId').html(data);
            }
        });
    }

    $("<span class='formatNomScanemail alert alert-warning'><?php echo  __d('scanemail', 'Scanemail.formatScriptnameAdd'); ?></span>").insertAfter("#ScanemailScriptname");
</script>