<?php

/**
 *
 * Workflows/get_workflows.ctp View File
 *
 * web-GFC : Gestion de Flux Citoyens (https://adullact.net/projects/webgfc)
 *
 * PHP version 7
 * @author Stéphane Sampaio
 * @copyright Initié par ADULLACT - Développé par ADULLACT Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 */
?>
<?php

if (!empty($workflows)) {
    $fields = array(
        'nom',
        'actif'
     );
    $actions = array(
        "edit" => array(
            "url" => '/workflows/edit',
            "updateElement" => "$('#infos .content')",
            "formMessage" => false
        ),
        "copieCircuit" => array(
            "url" => '/workflows/copieCircuit',
            "updateElement" => "$('#webgfc_content')",
            "refreshAction" => "loadCircuits();$('#infos .content').empty();"
            ),
        "delete" => array(
           "url" => '/workflows/delete',
           "updateElement" => "$('#webgfc_content')",
           "refreshAction" => "loadCircuits();$('#infos .content').empty();"
           )
        );
    $options = array('check_inactive' => true, 'inactive_value' => 0, 'inactive_field' => 'actif', 'inactive_model' => 'Circuit');
    $data = $this->Liste->drawTbody($workflows, 'Circuit', $fields, $actions, $options);
    ?>


<script type="text/javascript">
    var screenHeight = $(window).height() * 0.5;
</script>
<div  class="bannette_panel panel-body">
    <table id="table_workflows"
           data-toggle="table"
           data-search="true"
           data-locale = "fr-CA"
           data-height=screenHeight
           data-pagination = "true"
           >
    </table>
</div>
<script>
    //title legend (nombre de données)
    if (!$('.table-list h3 span').length < 1) {
        $('.table-list h3 span').remove();
    }
    $('.table-list h3').append('<?php echo $this->Liste->drawPanelHeading($workflows,$options); ?>');
    $('#table_workflows')
            .bootstrapTable({
                data:<?php echo $data;?>,
                columns: [
                    {
                        field: "nom",
                        title: "<?php echo __d("circuit","Circuit.nom"); ?>",
                        class: "nom"
                    },
                    {
                        field: "actif",
                        title: "<?php echo __d('circuit', 'Circuit.actif'); ?>",
                        class: "active_column"
                    },
                    {
                        field: "edit",
                        title: "Modifier",
                        class: "actions thEdit",
                        width: "80px",
                        align: "center"
                    },
                    {
                        field: "copieCircuit",
                        title: "Dupliquer",
                        class: "actions thCopie",
                        width: "80px",
                        align: "center"
                    },
                    {
                        field: "delete",
                        title: "Supprimer",
                        class: "actions thDelete",
                        width: "80px",
                        align: "center"
                    }
                ]
            })
            .on('page-change.bs.table', function (number, size) {
                addClassActive();
            });
    $(document).ready(function () {
        addClassActive();
        changeTableBannetteHeight();
        $(window).resize(function () {
            changeTableBannetteHeight();
        });
    });
    function changeTableBannetteHeight() {
        $(".fixed-table-container").css('height', $(window).height() * 0.5);
    }
    function addClassActive() {
        $('#table_workflows .active_column').hide();
        $('#table_workflows .active_column').each(function () {
            if ($(this).html() == 'false' || $(this).html() == 0) {
                $(this).parents('tr').addClass('inactive');
            }
        });
    }

</script>
<?php 
    echo $this->Liste->drawScript($workflows, 'Circuit', $fields, $actions, $options);
    echo $this->Js->writeBuffer();
} else {
    echo '<div class="alert alert-warning">'.__d('circuit', 'Circuit.void').'</div>';
}
?>
